unit Demopas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Printers;

type
  TfrmDemo = class(TForm)
    btnBMP: TButton;
    btnWMF: TButton;
    btnCopy: TButton;
    btnPrint: TButton;
    btnClose: TButton;
    PrintDialog1: TPrintDialog;
    procedure btnBMPClick(Sender: TObject);
    procedure btnWMFClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;
  ActualRows, ActualCols, ActualWidth, ActualHeight: longint;

function QRCopyToClipboard(): boolean;
         stdcall; far; external 'QRCodeWin32.dll' name 'QRCopyToClipboard'

function QRSaveAsBMP(FileName: PChar): boolean;
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSaveAsBMP'

function QRSaveAsWMF(FileName: PChar): boolean;
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSaveAsWMF'

procedure QRRender(handle: HDC; x: Integer; y: Integer)
          stdcall; far; external 'QRCodeWin32.dll' name 'QRRender'

procedure QRSetBackColor(red: integer; green: integer; blue:integer);
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSetBackColor'

procedure QRSetBarColor(red: integer; green: integer; blue:integer);
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSetBarColor'

procedure QRSetDefault(); stdcall; far; external 'QRCodeWin32.dll' name 'QRSetDefault'

procedure QRSetMessage(message: PChar);
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSetMessage'

procedure QRSetSize(width: Integer; height: Integer);
          stdcall; far; external 'QRCodeWin32.dll' name 'QRSetSize'

procedure QRConfigure(Version: Integer; Level: Integer; Mask: Integer);
          stdcall; far; external 'QRCodeWin32.dll' name 'QRConfigure'

procedure QRAppearance(ModuleSize: double; Orientation: Integer; BorderStyle: Integer);
         stdcall; far; external 'QRCodeWin32.dll' name 'QRAppearance'

procedure QRGetActualSize(ScreenIsTarget: boolean; TargetHDC: HDC;
	  		      var ActualWidth: longint; var ActualHeight: longint)
          stdcall; far; external 'QRCodeWin32.dll' name 'QRGetActualSize'

procedure QRGetActualRC(var ActualRows: longint; var ActualCols: longint)
          stdcall; far; external 'QRCodeWin32.dll' name 'QRGetActualRC'

implementation

{$R *.dfm}

procedure TfrmDemo.btnBMPClick(Sender: TObject);
begin
    // Message
    QRSetMessage('This is test data');

    // Bar color
    QRSetBarColor(0, 0, 0);

    // Background color
    QRSetBackColor(255, 255, 255);

    // Appearance (ModuleSize=0.09, Orientation=3, BorderStyle=0)
    QRAppearance(0.09, 3, 0);

    // QRCode Configurations
    // (Version=0 for Auto, Level=1 for 'M'-Level, Mask=1 for Mask-0)
    QRConfigure(0, 1, 1);

    // Get the actual rows and columns of QRCode barcode
    QRGetActualRC(ActualRows, ActualCols);

    // Get the actual barcode width and height
    // The size value is based on computer screen resolution
    QRGetActualSize(true, 0, ActualWidth, ActualHeight);

    // Image size = barcode size + extra space
    QRSetSize(ActualWidth + 120, ActualHeight + 150);

    QRSaveAsBMP('c:\QRCode.bmp');
end;

procedure TfrmDemo.btnWMFClick(Sender: TObject);
begin
    // Message
    QRSetMessage('ABCD 1234');

    // Bar color
    QRSetBarColor(0, 0, 0);

    // Background color
    QRSetBackColor(255, 255, 255);

    // Appearance (ModuleSize=0.07, Orientation=0, BorderStyle=0)
    QRAppearance(0.07, 0, 0);

    // QRCode Configurations
    // (Version=0 for Auto, Level=0 for 'L'-Level, Mask=0)
    QRConfigure(0, 0, 0);

    // Get the actual rows and columns of QRCode barcode
    QRGetActualRC(ActualRows, ActualCols);

    // Get the actual barcode width and height
    // Size value is based on computer screen resolution
    QRGetActualSize(true, 0, ActualWidth, ActualHeight);

    // Image size = barcode size + extra space
    QRSetSize(ActualWidth + 20, ActualHeight + 50);

    QRSaveAsWMF('c:\QRCode.wmf');

end;

procedure TfrmDemo.btnCopyClick(Sender: TObject);
begin
    // Choose default values for QRCode configurations
    QRSetDefault();

    // Get actual rows and columns of QRCode barcode
    QRGetActualRC(ActualRows, ActualCols);

    // Get the actual barcode width and height
    // The size value is based on computer screen resolution
    QRGetActualSize(true, 0, ActualWidth, ActualHeight);

    // Image size = barcode size + extra space
    QRSetSize(ActualWidth + 20, ActualHeight + 50);

    // Send the image to the clipboard
    QRCopyToClipboard();
end;

procedure TfrmDemo.btnPrintClick(Sender: TObject);
begin
   if PrintDialog1.Execute then
   begin
      // Send a print job to the printer
      Printer.BeginDoc;

      // Choose default info for QRCode barcode
      QRSetDefault();

      // Get the actual barcode width and height
      // The size value is based on printer resolution
      QRGetActualSize(false, Printer.Handle, ActualWidth, ActualHeight);

      // Image size = barcode size + extra space
      QRSetSize(ActualWidth + 220, ActualHeight + 260);

      // Print the barcode at the point(100, 500)
      QRRender(Printer.Handle, 100, 500);

      // Print the barcode at the point(100, 500)
      QRRender(Printer.Handle, 100, 500);

      // End the current print job
      Printer.EndDoc;
   end;
end;

procedure TfrmDemo.btnCloseClick(Sender: TObject);
begin
   // shut down the application
   Application.Terminate;
end;

end.
